unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, uMlSkinMenu, uMlSkinNCLabel,
  uMlSkinNCCtrlBase, uMlSkinNCButton, uMlStdCtrl, uMlSkinForm, StdCtrls,
  uMlSkinLabel, uMlSkinEdit, uMlSkinCtrls, uMlSkinPanel, uMlSkinSpinEdit,
  uMlSkinSearchEdit, uMlSkinPasswordEdit, uMlSkinBoxCtrls, uMlCustomButton,
  uMlSkinButton, Menus,
  uMlSkinCheckBox, uMlSkinRadioBox, uMlSkinMemo, uMlSkinScrollBar,
  uMlSkinProgressBar, uSkinRes, uMlQQAlign, uMlSkinNCImage, uMlTrayIcon,
  ComCtrls, uMlSkinTabs, VirtualTrees_ml, uMlSkinVirtualTree, uMlSkinMessageBox,
  GR32_Image_ml, uMlSkinSwitchButton, uMlSkinDatetimePicker;

type
  PTestData = ^TTestData;

  TTestData = record
    ColorID: Integer;
    Text: string;
    Col1: string;
    Col2: string;
    Col3: string;
  end;

  TForm1 = class(TForm)
    sknfrm1: TMlSkinForm;
    btnClose: TMlSkinSystemButton;
    btnMinimize: TMlSkinSystemButton;
    nclbl1: TMlSkinNCLabel;
    ncbtn1: TMlSkinNCButton;
    btnMaxmize: TMlSkinSystemButton;
    pm1: TPopupMenu;
    Online1: TMenuItem;
    Offline1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    lst1: TMlSkinListBox;
    mlsknbrdrpnl1: TMlSkinBorderPanel;
    sb1: TMlSkinScrollBar;
    sb2: TMlSkinScrollBar;
    mmo1: TMlSkinMemo;
    mlsknpnl1: TMlSkinPanel;
    N3: TMenuItem;
    mlqlgn1: TMlQQAlign;
    mlskngrpbx1: TMlSkinGroupBox;
    mlskncmg1: TMlSkinNCImage;
    mltrycn1: TMlTrayIcon;
    mlskngrpbx2: TMlSkinGroupBox;
    mlsknpgcntrl1: TMlSkinPageControl;
    mlskntbsht1: TMlSkinTabSheet;
    mlskntbsht2: TMlSkinTabSheet;
    mlskntbsht3: TMlSkinTabSheet;
    btn9: TMlSkinAnimateButton;
    btn10: TMlSkinAnimateButton;
    btn11: TMlSkinAnimateButton;
    btn12: TMlSkinAnimateButton;
    btn13: TMlURLButton;
    btn14: TMlURLButton;
    btn15: TMlURLButton;
    btn16: TMlSkinButton;
    lbl8: TMlSkinLabel;
    lbl2: TMlSkinLabel;
    edt1: TMlSkinEdit;
    edt2: TMlSkinEdit;
    lbl3: TMlSkinLabel;
    lbl4: TMlSkinLabel;
    lbl5: TMlSkinLabel;
    lbl1: TMlSkinLabel;
    lbl9: TMlSkinLabel;
    lbl10: TMlSkinLabel;
    lbl6: TMlSkinLabel;
    lbl7: TMlSkinLabel;
    btn4: TMlSkinButton;
    btn5: TMlSkinButton;
    btn2: TMlSkinToolButton;
    btn3: TMlSkinToolButton;
    chk1: TMlSkinCheckBox;
    rb1: TMlSkinRadioBox;
    rb2: TMlSkinRadioBox;
    chk2: TMlSkinCheckBox;
    chk3: TMlSkinCheckBox;
    btn8: TMlSkinButton;
    cbb3: TMlSkinColorComboBox;
    cbb1: TMlSkinComboBox;
    cbb2: TMlSkinComboBox;
    btn7: TMlSkinButton;
    mlsknbrdrpnl2: TMlSkinBorderPanel;
    sb4: TMlSkinScrollBar;
    vst1: TMlSkinVirtualStringTree;
    mlsknbrdrpnl3: TMlSkinBorderPanel;
    vst2: TMlSkinVirtualStringTree;
    sb5: TMlSkinScrollBar;
    btn1: TMlSkinButton;
    mlsknspndt1: TMlSkinSpinEdit;
    edt4: TMlSkinSearchEdit;
    edt3: TMlSkinPasswordEdit;
    mlsknswtchbtn1: TMlSkinSwitchButton;
    mlsknswtchbtn2: TMlSkinSwitchButton;
    mn1: TMlSkinMenu;
    grs1: TMlSkinProgressBar;
    grsProgressBar: TMlSkinProgressBar;
    dp1: TMlSkinDatetimePicker;
    procedure ncbtn1Click(Sender: TObject);
    procedure chk3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btn8Click(Sender: TObject);
    procedure mlkmndlg1MouseClickOutside(Sender: TObject);
    procedure chk2Click(Sender: TObject);
    procedure vst1PaintText(Sender: TBaseVirtualTree_ml;
      const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      TextType: TVSTTextType);
    procedure vst2PaintText(Sender: TBaseVirtualTree_ml;
      const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      TextType: TVSTTextType);
    procedure btn14Click(Sender: TObject);
    procedure btn15Click(Sender: TObject);
    procedure btn16Click(Sender: TObject);
    procedure grsProgressBarChanged(Sender: TObject);
    {$IFDEF Unicode}
    procedure vst1GetText(Sender: TBaseVirtualTree_ml; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText:
      string);
    procedure vst2GetText(Sender: TBaseVirtualTree_ml; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText:
      string);
  {$ELSE}
    procedure vst1GetText(Sender: TBaseVirtualTree_ml; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText:
      WideString);
    procedure vst2GetText(Sender: TBaseVirtualTree_ml; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
  {$ENDIF}
  private
    { Private declarations }
    procedure InitTreeView;
    procedure InitListView;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  ShellAPI, frmMlFormSkinEditor, Unit2, Unit3;

{$R *.dfm}

procedure TForm1.btn14Click(Sender: TObject);
begin
  MlMessageBox('ʾ', 'MlSkinϢԻ', biInformation, []);
end;

procedure TForm1.btn15Click(Sender: TObject);
var
  t: Boolean;
begin
  t := False;
  if MlMessageBox('л', 'ǷҪMlSkinʽ棿', biConfirmation, [mbYes, mbNo],
    True, t) = mrYes then
  begin
    Shellexecute(0, nil, 'http://www.pngui.com', nil,
      nil, SW_SHOWNORMAL);
  end;
end;

procedure TForm1.btn16Click(Sender: TObject);
begin
  with TForm2.Create(Self) do
  begin
    Show;
  end;
end;

procedure TForm1.btn8Click(Sender: TObject);
var
  Pt: TPoint;
begin
  btn8.Down := not btn8.Down;
  if btn8.Down then
  begin
    Form3 := TForm3.Create(Self);
    // ò˵嵯λ
    Pt.X := btn8.Left;
    Pt.Y := btn8.Top + btn8.Height + 1;
    Pt := ClientToScreen(Pt);
    if Pt.X + Form3.Width > Screen.Width then
      Pt.X := Screen.Width - Form3.Width;
    with Form3 do
    begin
      Left := Pt.X;
      Top := Pt.Y;
      Show;
    end;
    Form3.mlkmndlg1.OnMouseClickOutside := mlkmndlg1MouseClickOutside;
    Form3.mlkmndlg1.Capture(Form3);
  end
  else
  begin
    if Assigned(Form3) then
      Form3.mlkmndlg1.Stop;
  end;
end;

procedure TForm1.mlkmndlg1MouseClickOutside(Sender: TObject);
begin
  Form3.Close;
  btn8.Down := False;
end;

procedure TForm1.chk2Click(Sender: TObject);
begin
  mlqlgn1.Active := chk2.Checked;
end;

procedure TForm1.chk3Click(Sender: TObject);
begin
  mmo1.Transparent := chk3.Checked;
  sb1.Transparent := chk3.Checked;
  sb2.Transparent := chk3.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  m: TMenuItem;
begin
  // ̬Ӳ˵
  m := TMenuItem.Create(N3);
  m.Caption := 'ɼ';
  N3.Add(m);
  mn1.DrawMenuItem(m); // 
  m := TMenuItem.Create(N3);
  m.Caption := '߶';
  N3.Add(m);
  mn1.DrawMenuItem(m); // 
  vst1.NodeDataSize := SizeOf(TTestData);
  vst2.NodeDataSize := SizeOf(TTestData);
  InitTreeView;
  InitListView;
end;

procedure TForm1.grsProgressBarChanged(Sender: TObject);
begin
  mlsknpnl1.Alpha := grsProgressBar.Value;
end;

procedure TForm1.InitListView;
var
  PIt: PTestData;
  i: Integer;
  nd: PVirtualNode;
begin
  with vst2 do
  begin
    try
      BeginUpdate;
      for i := 0 to 100 do
      begin
        nd := AddChild(nil);
        PIt := GetNodeData(nd);
        PIt.Text := 'Text' + IntToStr(i + 1);
        PIt.Col1 := 'Col1 Text';
        PIt.Col2 := 'Col2 Text';
        PIt.Col3 := 'Col3 Text';
      end;
    finally
      EndUpdate;
    end;
  end;
end;

procedure TForm1.InitTreeView;
var
  nd1, nd2: PVirtualNode;
  i, j: Integer;
  PIt: PTestData;
begin
  with vst1 do
  begin
    try
      BeginUpdate;
      for i := 0 to 5 do
      begin
        nd1 := AddChild(nil);
        PIt := GetNodeData(nd1);
        PIt.Text := 'Parent' + IntToStr(i + 1);
        PIt.ColorID := 0;
        for j := 0 to 3 do
        begin
          nd2 := AddChild(nd1);
          PIt := GetNodeData(nd2);
          PIt.Text := 'SubText' + IntToStr(j + 1);
          PIt.ColorID := 1;
        end;
      end;
    finally
      EndUpdate;
    end;
  end;
end;

procedure TForm1.ncbtn1Click(Sender: TObject);
begin
  with TMlFormSkinEditorForm.Create(Self) do
  begin
    ShowModal;
    Free;
  end;
end;

{$IFDEF Unicode}
    procedure TForm1.vst1GetText(Sender: TBaseVirtualTree_ml; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText:
      string);
{$ELSE}
    procedure TForm1.vst1GetText(Sender: TBaseVirtualTree_ml; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText:
      WideString);
{$ENDIF}
var
  PIt: PTestData;
begin
  with Sender do
  begin
    PIt := GetNodeData(Node);
    CellText := PIt^.Text;
  end;
end;

procedure TForm1.vst1PaintText(Sender: TBaseVirtualTree_ml;
  const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  TextType: TVSTTextType);
var
  PIt: PTestData;
begin
  PIt := Sender.GetNodeData(Node);
  if PIt.ColorID = 0 then
    TargetCanvas.Font.Color := $00F6B536
  else
    TargetCanvas.Font.Color := clRed;
end;

procedure TForm1.vst2PaintText(Sender: TBaseVirtualTree_ml;
  const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  TextType: TVSTTextType);
begin
  case Column of
    0:
      begin
        TargetCanvas.Font.Color := $00FFC447;
      end;
    1:
      begin
        TargetCanvas.Font.Color := $007777F9;
      end;
    2:
      begin
        TargetCanvas.Font.Color := $0081A3E2;
      end;
    3:
      begin
        TargetCanvas.Font.Color := $007ED688;
      end;
  end;
end;



  {$IFDEF Unicode}
    procedure TForm1.vst2GetText(Sender: TBaseVirtualTree_ml; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText:
      string);
  {$ELSE}
    procedure TForm1.vst2GetText(Sender: TBaseVirtualTree_ml; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText:
      WideString);
  {$ENDIF}
var
  PIt: PTestData;
begin
  with Sender do
  begin
    PIt := GetNodeData(Node);
    case Column of
      0:
        CellText := PIt^.Text;
      1:
        CellText := PIt^.Col1;
      2:
        CellText := PIt^.Col2;
      3:
        CellText := PIt^.Col3;
    end;
  end;
end;

end.
