unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, uMlStdCtrl, uMlSkinForm, uMlSkinNCButton,
 {$IFDEF UNICODE}pngimage{$ELSE}pngimage_ml{$ENDIF}, uMlSkinNCCtrlBase,
  uMlSkinNCImage, uMlCustomButton, uMlSkinColorButton, uMlSkinIconButtonList,
  GR32_Image_ml, uMlSkinCtrls, uMlSkinPanel, uMlSkinLabel, uMlSkinNCLabel,
  uMlFormBorder, ImgList, GR32_ml, uMlGR32Lib, uMlComm, uMlSkinCheckBox;

type
  TForm4 = class(TForm)
    lbl1: TMlSkinLabel;
    lst1: TMlSkinIconButtonList;
    btn1: TMlSkinColorButton;
    btnmlsknsystmbtn2: TMlSkinSystemButton;
    btnmlsknsystmbtn1: TMlSkinSystemButton;
    sknfrmmlsknfrm1: TMlSkinForm;
    mlfrmlyrbrdr1: TMlFormLayerBorder;
    nclbl1: TMlSkinNCLabel;
    btn2: TMlSkinColorButton;
    btn3: TMlSkinColorButton;
    il1: TImageList;
    lbl2: TMlSkinLabel;
    lst2: TMlSkinIconButtonList;
    il2: TImageList;
    btn4: TMlSkinColorButton;
    chk1: TMlSkinCheckBox;
    chk2: TMlSkinCheckBox;
    procedure btn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btn2Click(Sender: TObject);
    procedure btn3Click(Sender: TObject);
    procedure lst1ClickItem(Sender: TObject; ItemIndex: Integer);
    procedure btn4Click(Sender: TObject);
    procedure lst2DrawItem(Sender: TObject; Bmp32: TBitmap32;
      ItemData: TMlIconButtonItemData);
    procedure chk1Click(Sender: TObject);
    procedure chk2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

procedure TForm4.btn1Click(Sender: TObject);
var
  i, j: Integer;
  it: TMlIconButtonItem;
begin
  with lst1 do
  begin
    Items.BeginUpdate;
    i := 0;
    j := 0;
    while i < 24 do
    begin
      it := Items.Add;
      it.Caption := IntToStr(j);
      it.ImageNormalIndex := i;
      it.ImageHotIndex := i + 1;
      Inc(i, 2);
      Inc(j);
    end;
    // һӡť
    it := Items.Add;
    it.Caption := '';
    it.ImageNormalIndex := 34;
    it.ImageHotIndex := 35;
    it.ReadOnly := True;
    it.Tag := 1;
    Items.EndUpdate;
  end;
end;

procedure TForm4.btn2Click(Sender: TObject);
begin
  lst1.EnterEdit;
end;

procedure TForm4.btn3Click(Sender: TObject);
begin
  lst1.ExitEdit;
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  lst1.FastDrawMode := True;
  lst2.FastDrawMode := True;
  btn1.Click;
  btn4.Click;
end;

procedure TForm4.lst1ClickItem(Sender: TObject; ItemIndex: Integer);
var
  it: TMlIconButtonItem;
  k: Integer;
begin
  if TMlIconButtonItem(Sender).Tag = 1 then
  begin
    k := lst1.Items.Count - 1;
    if k < 0 then
      k := 0;
    it := lst1.Items.Insert(k);
    it.Caption := IntToStr(k);
    it.ImageNormalIndex := 32;
    it.ImageHotIndex := 33;
  end
  else
    ShowMessage('ItemClick' + lst1.Items[ItemIndex].Caption);
end;

procedure TForm4.btn4Click(Sender: TObject);
var
  i: integer;
  it: TMlIconButtonItem;
begin
  with lst2 do
  begin
    Items.BeginUpdate;
    for i := 0 to 9 do
    begin
      it := Items.Add;
      it.Caption := ExtractFilePath(ParamStr(0)) + 'Images\' + IntToStr(i + 1) + '.png';
    end;
    Items.EndUpdate;
  end;
end;

procedure TForm4.chk1Click(Sender: TObject);
begin
  lst1.ShakeInEdit := chk1.Checked;
end;

procedure TForm4.chk2Click(Sender: TObject);
begin
  lst1.AutoDrag := chk2.Checked;
end;

procedure TForm4.lst2DrawItem(Sender: TObject; Bmp32: TBitmap32;
  ItemData: TMlIconButtonItemData);
var
  png: TPngImage;
  x, y, k: Integer;
begin
  inherited;
  png := TPngImage.Create;
  png.LoadFromFile(ItemData.Caption);
  DrawPng(png, ItemData.Rect.Left, ItemData.Rect.Top, Bmp32);
  if ItemData.Checked then
    k := 1
  else
    k := 0;
  x := ItemData.Rect.Left + (GetRectWidth(ItemData.Rect) - il2.Width) div 2;
  y := ItemData.Rect.Bottom - 15;
  il2.Draw(Bmp32.Canvas, x, y, k);
  png.Free;
end;

end.
