unit Unit7;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, uMlStdCtrl, uMlSkinForm,
  GR32_Image_ml, uMlSkinCtrls, uMlSkinPanel, uMlSkinNCCtrlBase, uMlSkinNCButton,
  uMlCustomButton, uMlSkinButton, uMlSkinNCLabel, uMlSkinLabel,
  uMlSkinScrollMsgBar, uMlSkinCheckBox, uMlSkinBoxCtrls, uMlSkinEdit,
  uMlSkinSpinEdit, ExtCtrls, jpeg;

type
  TForm7 = class(TForm)
    pnl1: TMlSkinPanel;
    sm1: TMlSkinScrollMsgBar;
    sf1: TMlSkinForm;
    systmbtn1: TMlSkinSystemButton;
    nclbl1: TMlSkinNCLabel;
    btn3: TMlSkinImageButton;
    btn4: TMlSkinImageButton;
    cbb1: TMlSkinComboBox;
    lbl2: TMlSkinLabel;
    lbl3: TMlSkinLabel;
    chk1: TMlSkinCheckBox;
    se1: TMlSkinSpinEdit;
    chk2: TMlSkinCheckBox;
    img1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure sm1ItemClick(Sender: TObject; Item: TScrollMsgBarItem);
    procedure btn3Click(Sender: TObject);
    procedure btn4Click(Sender: TObject);
    procedure cbb1Change(Sender: TObject);
    procedure chk2Click(Sender: TObject);
    procedure chk1Click(Sender: TObject);
    procedure se1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form7: TForm7;

implementation
uses
  uGR32_Png;

{$R *.dfm}

procedure TForm7.btn3Click(Sender: TObject);
begin
  sm1.Prev;
end;

procedure TForm7.btn4Click(Sender: TObject);
begin
  sm1.Next;
end;

procedure TForm7.cbb1Change(Sender: TObject);
begin
  sm1.AnimateEasing := TAnimateEasing(cbb1.ItemIndex);
end;

procedure TForm7.chk1Click(Sender: TObject);
begin
  sm1.AutoScroll := chk1.Checked;
end;

procedure TForm7.chk2Click(Sender: TObject);
begin
  sm1.AllowClick := chk2.Checked;
end;

procedure TForm7.FormCreate(Sender: TObject);
var
  it: TScrollMsgBarItem;
begin
  sm1.BeginUpdate;
  sm1.HookPaintBufferProc := False;
  sm1.Bitmap.LoadFromFile('.\Res\bg.jpg');
  it := sm1.AddItem;
  it.Text.Title := ' Ů10ǹ ';
  it.Text.Font.Color := clWhite;
  it.Text.FontHot.Color := $0000CCFF;
  LoadPNGintoBitmap32(it.Icon, '.\Res\silver.png');

  it := sm1.AddItem;
  it.Text.Title := ' Ӿ200Ӿ ';
  it.Text.Font.Color := clWhite;
  it.Text.FontHot.Color := $0000CCFF;
  LoadPNGintoBitmap32(it.Icon, '.\Res\gold-metal.png');

  it := sm1.AddItem;
  it.Text.Title := '  56kg Ȫ';
  it.Text.Font.Color := clWhite;
  it.Text.FontHot.Color := $0000CCFF;
  LoadPNGintoBitmap32(it.Icon, '.\Res\gold-metal.png');

  it := sm1.AddItem;
  it.Text.Title := 'ͭ Ӿ200׸˻Ӿ ˳';
  it.Text.Font.Color := clWhite;
  it.Text.FontHot.Color := $0000CCFF;
  LoadPNGintoBitmap32(it.Icon, '.\Res\bronze.png');

  it := sm1.AddItem;
  it.Text.Title := ' ˮŮ3 ʩ͢';
  it.Text.Font.Color := clWhite;
  it.Text.FontHot.Color := $0000CCFF;
  LoadPNGintoBitmap32(it.Icon, '.\Res\gold-metal.png');
  sm1.EndUpdate;
end;

procedure TForm7.se1Change(Sender: TObject);
begin
  sm1.AnimateStep := se1.Value;
end;

procedure TForm7.sm1ItemClick(Sender: TObject; Item: TScrollMsgBarItem);
begin
  ShowMessage(Item.Text.Title);
end;

end.

