unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GR32_Image_ml, uMlSkinCtrls, uMlSkinShape, uMlSkinNCCtrlBase,
  uMlSkinNCButton, uMlStdCtrl, uMlSkinForm, uMlSkinCheckBox, uMlSkinPanel,
  uMlSkinLabel, uMlSkinEdit, uMlSkinSpinEdit, uMlSkinNCLabel;

type
  TForm1 = class(TForm)
    mlsknshp1: TMlSkinShape;
    mlsknshp2: TMlSkinShape;
    mlsknshp3: TMlSkinShape;
    sf1: TMlSkinForm;
    systmbtn1: TMlSkinSystemButton;
    mlsknshp4: TMlSkinShape;
    chk1: TMlSkinCheckBox;
    chk2: TMlSkinCheckBox;
    mlsknshp5: TMlSkinShape;
    mlsknshp6: TMlSkinShape;
    lbl1: TMlSkinLabel;
    se1: TMlSkinSpinEdit;
    lbl2: TMlSkinLabel;
    edt1: TMlSkinEdit;
    nclbl1: TMlSkinNCLabel;
    lbl3: TMlSkinLabel;
    edt2: TMlSkinEdit;
    lbl4: TMlSkinLabel;
    se2: TMlSkinSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure chk1Click(Sender: TObject);
    procedure se1Change(Sender: TObject);
    procedure edt1Change(Sender: TObject);
    procedure edt2Change(Sender: TObject);
    procedure mlsknshp5Click(Sender: TObject);
  private
    { Private declarations }
    procedure DoChanged;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.chk1Click(Sender: TObject);
begin
  DoChanged;
end;

procedure TForm1.DoChanged;
begin
  with mlsknshp1 do
  begin
    Alpha := se2.Value;
    Pen.Visible := chk1.Checked;
    Pen.Color := mlsknshp5.Brush.Color;
    Pen.Width := se1.Value;
    Brush.Visible := chk2.Checked;
    Brush.Color := mlsknshp6.Brush.Color;
    RoundRadius := StrToIntDef(edt1.Text, 0);
  end;
  with mlsknshp2 do
  begin
    Alpha := se2.Value;
    Pen.Visible := chk1.Checked;
    Pen.Color := mlsknshp5.Brush.Color;
    Pen.Width := se1.Value;
    Brush.Visible := chk2.Checked;
    Brush.Color := mlsknshp6.Brush.Color;
    RoundRadius := StrToIntDef(edt1.Text, 0);
  end;
  with mlsknshp3 do
  begin
    Alpha := se2.Value;
    Pen.Visible := chk1.Checked;
    Pen.Color := mlsknshp5.Brush.Color;
    Pen.Width := se1.Value;
    Brush.Visible := chk2.Checked;
    Brush.Color := mlsknshp6.Brush.Color;
    RoundRadius := StrToIntDef(edt1.Text, 0);
  end;
  with mlsknshp4 do
  begin
    Pen.Color := mlsknshp5.Brush.Color;
  end;

  with sf1 do
  begin
    TitlerColor := mlsknshp6.Brush.Color;
    FrameColor := mlsknshp5.Brush.Color;
    InvalidateNC;
  end;
end;

procedure TForm1.edt1Change(Sender: TObject);
begin
  DoChanged;
end;

procedure TForm1.edt2Change(Sender: TObject);
begin
  mlsknshp3.SvgPath := edt2.Text;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  systmbtn1.CloseImage := ExtractFilePath(ParamStr(0)) + 'close.png';

  with TStringList.Create do
  begin
    LoadFromFile(ExtractFilePath(ParamStr(0)) + 'Camera.txt');
    mlsknshp3.SvgPath := Text;
    Free;
  end;
end;

procedure TForm1.mlsknshp5Click(Sender: TObject);
begin
  with TColorDialog.Create(Self) do
  begin
    if Execute then
    begin
      TMlSkinShape(Sender).Brush.Color := Color;
      DoChanged;
    end;
    Free;
  end;
end;

procedure TForm1.se1Change(Sender: TObject);
begin
  DoChanged;
end;

end.
