unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GR32_Image_ml, uMlSkinCtrls, uMlSkinNCLabel, uMlSkinNCCtrlBase,
  uMlSkinNCButton, uMlStdCtrl, uMlSkinForm, uMlSkinLabel, uMlComm, uMlFormBorder,
  uMlSkinPanel, uMlSkinCheckBox, uMlSkinEdit, uMlSkinComboBoxEx, uMlSkinMemo;

type
  TForm2 = class(TForm)
    sf1: TMlSkinForm;
    systmbtn1: TMlSkinSystemButton;
    nclbl1: TMlSkinNCLabel;
    MlSkinLabel1: TMlSkinLabel;
    MlSkinLabel2: TMlSkinLabel;
    MlFormLayerBorder1: TMlFormLayerBorder;
    MlSkinComboBoxEx1: TMlSkinComboBoxEx;
    MlSkinCheckBox1: TMlSkinCheckBox;
    MlSkinComboBoxEx2: TMlSkinComboBoxEx;
    MlSkinCheckBox2: TMlSkinCheckBox;
    MlSkinMemoEx1: TMlSkinMemoEx;
    MlSkinLabel3: TMlSkinLabel;
    procedure MlSkinCheckBox1Changed(Sender: TObject);
    procedure MlSkinCheckBox2Changed(Sender: TObject);
    procedure MlSkinComboBoxEx1Change(Sender: TObject);
    procedure MlSkinComboBoxEx2CheckStateChanged(Sender: TObject;
      const Text: string; ItemIndexs: TItemIndexs);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.MlSkinCheckBox1Changed(Sender: TObject);
begin
  MlSkinComboBoxEx1.Options.ActivePinyinFilter := MlSkinCheckBox1.Checked;
end;

procedure TForm2.MlSkinCheckBox2Changed(Sender: TObject);
begin
  if MlSkinCheckBox2.Checked then
  begin
    MlSkinComboBoxEx2.Options.DropdownMenuWidth := 300;
    MlSkinComboBoxEx2.Options.DropdownMenuHeight := 400;
  end
  else
  begin
    MlSkinComboBoxEx2.Options.DropdownMenuWidth := 199;
    MlSkinComboBoxEx2.Options.DropdownMenuHeight := 242;
  end;
end;

procedure TForm2.MlSkinComboBoxEx1Change(Sender: TObject);
begin
  MlSkinMemoEx1.Memo.Text := MlSkinComboBoxEx1.Text;
end;

procedure TForm2.MlSkinComboBoxEx2CheckStateChanged(Sender: TObject;
  const Text: string; ItemIndexs: TItemIndexs);
begin
  MlSkinMemoEx1.Memo.Text := Text;
end;

end.

