unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GR32_Image_ml, uMlSkinCtrls, uMlSkinPanel, uMlSkinEdit, uMlSkinMemo,
  uMlSkinLabel;

type
  TForm1 = class(TForm)
    edtPopupItems: TMlSkinEdit;
    mmo1: TMlSkinMemoEx;
    lb1: TMlSkinLabel;
    procedure edt1EdItems0Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FDemoData: TStrings;
    procedure DoMouseClickOutside1(Sender: TObject);
    procedure DoOnCheckedChanged(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  frmPopupList;

{$R *.dfm}

procedure TForm1.DoMouseClickOutside1(Sender: TObject);
begin
  PopupListForm.Close;
  edtPopupItems.Tag := 0;
end;

procedure TForm1.DoOnCheckedChanged(Sender: TObject);
begin
  edtPopupItems.Text := Format('ѡ%dĿ', [PopupListForm.CheckedItems.Count]);
  mmo1.Memo.Text := PopupListForm.CheckedItems.Text;
end;

procedure TForm1.edt1EdItems0Click(Sender: TObject);
var
  Pt: TPoint;
begin
  if edtPopupItems.Tag = 0 then
  begin
    edtPopupItems.Tag := 1;
    PopupListForm := TPopupListForm.Create(Self);
    PopupListForm.OnCheckedChanged := DoOnCheckedChanged;
    //
    PopupListForm.Items.Assign(FDemoData);
    //ѡ
    PopupListForm.CheckedItems.Text := mmo1.Memo.Text;
    //ò˵嵯λ
    Pt.X := edtPopupItems.Left;
    Pt.Y := edtPopupItems.Top + edtPopupItems.Height + 1;
    Pt := ClientToScreen(Pt);
    if Pt.X + PopupListForm.Width > Screen.Width then
      Pt.X := Screen.Width - PopupListForm.Width;
    with PopupListForm do
    begin
      Left := Pt.X;
      Top := Pt.Y;
      Show;
    end;
    PopupListForm.mlkmndlg1.OnMouseClickOutside := DoMouseClickOutside1;
    PopupListForm.mlkmndlg1.Capture(PopupListForm);
  end
  else
  begin
    edtPopupItems.Tag := 0;
    if Assigned(PopupListForm) then
      PopupListForm.mlkmndlg1.Stop;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FDemoData := TStringList.Create;
  FDemoData.CommaText :=
    'Travel,Beverage,Automotive,Education,CPG,Government,Nonprofit,Email,Event Screen,Commerce,Rights,Other';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FDemoData.Free;
end;

end.

