unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics,
  Controls, Forms, Dialogs, uMlSkinNCCtrlBase, uMlSkinNCButton,
  jpeg, uMlStdCtrl, uMlSkinForm, uMlSkinNCLabel, uMlSkinEdit,
  GR32_Image_ml, uMlSkinCtrls,
  uMlSkinPanel, uMlCustomButton, uMlSkinColorButton,
  uMlSkinToolbar, uMlSkinLabel;

type
  TForm2 = class(TForm)
    sknfrm1: TMlSkinForm;
    btn1: TMlSkinSystemButton;
    nclbl1: TMlSkinNCLabel;
    pnl2: TMlSkinPanel;
    pnl1: TMlSkinPanel;
    edt1: TMlSkinEdit;
    btn2: TMlSkinColorButton;
    mlskntlbr1: TMlSkinToolbar;
    lbl1: TMlSkinLabel;
    procedure edt1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure edt1Change(Sender: TObject);
    procedure btn2Click(Sender: TObject);
  private
    { Private declarations }
    FLock, FIgnore: Boolean;
    procedure DoMouseClickOutside(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses
  frmSearchList;

{$R *.dfm}

procedure TForm2.btn2Click(Sender: TObject);
begin
  ShowMessage('' + edt1.Text + ' ( ' + mlskntlbr1.Items
    [mlskntlbr1.FocusItemIndex].Text.Text + ' )');
end;

procedure TForm2.DoMouseClickOutside(Sender: TObject);
var
  s: string;
begin
  if FIgnore then
    Exit;
  if SearchListForm.HotNodeData <> nil then
    s := SearchListForm.HotNodeData^.Caption
  else
    s := '';
  SearchListForm.Close;
  edt1.EdItems[0].Tag := 0;
  edt1.SetFocus;
  if s <> '' then
  begin
    FLock := True;
    edt1.Text := s;
    edt1.SelLength := 0;
    FLock := False;
  end;
end;

procedure TForm2.edt1Change(Sender: TObject);
var
  Pt: TPoint;
begin
  if FLock then
    Exit;
  if edt1.Text <> '' then
  begin
    if edt1.EdItems[0].Tag = 0 then
    begin
      edt1.EdItems[0].Tag := 1;
      SearchListForm := TSearchListForm.Create(Self);
      SearchListForm.Width := edt1.Width;
      // ò˵嵯λ
      Pt.X := edt1.Left;
      Pt.Y := edt1.Top + edt1.Height;
      Pt := pnl1.ClientToScreen(Pt);
      if Pt.X + SearchListForm.Width > Screen.Width then
        Pt.X := Screen.Width - SearchListForm.Width;
      with SearchListForm do
      begin
        Left := Pt.X;
        Top := Pt.Y;
        Key := edt1.Text;
      end;
      ShowWindow(SearchListForm.Handle, SW_SHOWNOACTIVATE);  //ؼ
      SearchListForm.Visible := True;

      SearchListForm.mlkmndlg1.OnMouseClickOutside := DoMouseClickOutside;
      SearchListForm.mlkmndlg1.Capture(SearchListForm);
    end
    else
    begin
      if Assigned(SearchListForm) then
        SearchListForm.Key := edt1.Text;
    end;
  end
  else
  begin
    edt1.EdItems[0].Tag := 0;
    if Assigned(SearchListForm) then
      SearchListForm.mlkmndlg1.Stop;
  end;
end;

procedure TForm2.edt1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = 40 then // 
  begin
    FIgnore := True;
    if Assigned(SearchListForm) then
    begin
      SearchListForm.SetFocus;
      with SearchListForm.vdt1 do
      begin
        SetFocus;
        FocusedNode := GetFirst;
      end;
    end;
    FIgnore := False;
  end;
end;

end.
